// Code generated by "enumer -type=OutputType -json -text -yaml -sql"; DO NOT EDIT.

//
package outputTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _OutputTypeName = "BothHTMLPDF"

var _OutputTypeIndex = [...]uint8{0, 4, 8, 11}

func (i OutputType) String() string {
	if i < 0 || i >= OutputType(len(_OutputTypeIndex)-1) {
		return fmt.Sprintf("OutputType(%d)", i)
	}
	return _OutputTypeName[_OutputTypeIndex[i]:_OutputTypeIndex[i+1]]
}

var _OutputTypeValues = []OutputType{0, 1, 2}

var _OutputTypeNameToValueMap = map[string]OutputType{
	_OutputTypeName[0:4]:  0,
	_OutputTypeName[4:8]:  1,
	_OutputTypeName[8:11]: 2,
}

// OutputTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func OutputTypeString(s string) (OutputType, error) {
	if val, ok := _OutputTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to OutputType values", s)
}

// OutputTypeValues returns all values of the enum
func OutputTypeValues() []OutputType {
	return _OutputTypeValues
}

// IsAOutputType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i OutputType) IsAOutputType() bool {
	for _, v := range _OutputTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for OutputType
func (i OutputType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for OutputType
func (i *OutputType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("OutputType should be a string, got %s", data)
	}

	var err error
	*i, err = OutputTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for OutputType
func (i OutputType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for OutputType
func (i *OutputType) UnmarshalText(text []byte) error {
	var err error
	*i, err = OutputTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for OutputType
func (i OutputType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for OutputType
func (i *OutputType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = OutputTypeString(s)
	return err
}

func (i OutputType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *OutputType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := OutputTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
